%
% File name:  Bat.m 
% Contains:   Batteries function
	
function [bat, grid] = Bat( grid )
Grid_price = [0.17 0.17 0.17 0.17 0.17 0.17 0.17 0.49 0.49 0.49 0.83 ...
              0.83 0.83 0.83 0.83 0.49 0.49 0.49 0.83 0.83 0.83 0.49 ...
              0.49 0.17];
% MWh %160; % Total total_battery_capacity 160 Kwh
total_battery_capacity      = 80; 
battery_capacity            = 20; % intital capacity Kwh
excessive_renewable_power   = zeros(1,24);
temp = grid<0;
excessive_renewable_power(find(temp))= abs(grid(find(temp)));
battery   = zeros(1,24);
for i=1:24
    discharging_rate = (total_battery_capacity/3) * ((battery_capacity/total_battery_capacity)^.5);
    charging_rate    = abs(discharging_rate-(total_battery_capacity/3));  
    if excessive_renewable_power(i)>0 % Charge from renewable
        if battery_capacity < total_battery_capacity
            if excessive_renewable_power(i) > charging_rate
                battery_capacity    = battery_capacity + charging_rate;
                battery(i)          = battery(i) - charging_rate;
            else
                battery_capacity = battery_capacity + excessive_renewable_power(i);
                battery(i)= battery(i) - excessive_renewable_power(i);
                excessive_renewable_power(i) = 0;
            end
        end
    else
        if Grid_price(i)<= 0.3     %charge the battery from grid.
            if battery_capacity < total_battery_capacity
                battery_capacity    = battery_capacity + charging_rate;
                battery(i)          = battery(i) - charging_rate;
            end
        end
        if battery_capacity > 20   % we can't discharge below this
            if Grid_price(i)>= 0.8
                battery_capacity    = battery_capacity - discharging_rate;
                battery(i)          =  discharging_rate;
            end
        end
    end
end
bat     = battery;
bat     = bat-sum(bat)/24;
grid    = grid-bat;
end