%
% File name:  Cost_calculator.m 
% Contains:   A Microgrids one-day cost calculator
 
%clear;
clc;
%close all;
tic; % Time counting start
 
buy_price  = [0.17 0.17 0.17 0.17 0.17 0.17 0.17 0.49 0.49 0.49 0.83 ...
              0.83 0.83 0.83 0.83 0.49 0.49 0.49 0.83 0.83 0.83 0.49 ...
              0.49 0.17];
sell_price = [0.13 0.13 0.13 0.13 0.13 0.13 0.13 0.38 0.38 0.38 0.65 ...
              0.65 0.65 0.65 0.63 0.38 0.38 0.38 0.65 0.65 0.65 0.38 ...
              0.38 0.13];
DER_cost   = zeros(1,24);
batter_cost_i= zeros(1,24);
var        = zeros(6,24);
 
load('New_Dispatch_all.mat'); %loading data from a MATLAB data file
% Colunm
% I   II  III  IV   V     VI  VII    VIII     IX
% PV  WT  MT1  MT2  MT3   FC  Grid   Battery  Load
 
Load_cost = Dispatch_all(9,:) .* buy_price;
Total_Load_cost = sum(Load_cost);
disp('In the first case when microgrids purchased all power from the main grid they were required to spend (in RMB per Day) = ');
disp(Total_Load_cost);
 
var(1:4,:)  = Dispatch_all(3:6,:);
var(5  ,:)  = Dispatch_all(9,:) - (Dispatch_all(1,:)+Dispatch_all(2,:));
var(6  ,:)  = 1:24;
 
% MT1         = var(1);
% MT2         = var(2);
% MT3         = var(3);
% FC          = var(4);
% Actual_PL   = var(5);
% MG          = Actual_PL -(MT1 + MT2 + MT3 + FC);
% i         = var(6);
% actual_load = PL - PV_WT';
 
for i=1:24
    DER_cost(i) = Cost_dispatch(var(:,i));
    
    if(Dispatch_all(8,i)>0)
        batter_cost_i(i) = Dispatch_all(8,i)*buy_price(i);
    else
        batter_cost_i(i) = Dispatch_all(8,i)*-1*sell_price(i);
    end
end
DER = sum(DER_cost);
disp('After proposed changes this cost was reduced (in RMB per Day) = ');
disp(DER);
battery = sum(batter_cost_i);
disp('Battery Contribution (In RMB per Day) =  ');
disp (battery);
disp('Total time used in calculations = ')
toc  % Total time used in calculations