%
% File name:  FC.m
% Contains:   Fuel cell output power and cost calculation

%-----------------Fuel cell Cost    (FC)-----------------%
function cost_FC = FuelCell(var)
%Fuel cell output parameters
FC      = var(4);      % Power proded by Fuel cell
d       = 0.1;
LHVng   = 9.7;
Cng     = 2.05;
Kfc     = 0.0293;
a1      = 8;
c1      = 0.014;
a2      = 6;
c2      = 0.0027;
a3      = 0.023;
c3      = 489;
Sfc     = 0.4097;
Lfc     = 10;
InsCost4= 42750;
Pi4     = 20;
cf4     = 0.3673;
%-----Fuel cell state
P4i     = 22.2991;
Ptt     = abs(FC-P4i);
%-----Fuel cell fuel cost
Nfc     = -0.0043*FC+0.6735;
N1      = FC/LHVng/Nfc;
C2      = Cng*N1;
%-----Fuel cell maintenance cost
OM4     = Kfc*FC;
%-----Fuel cell pollutant treatment cost
Cem2    = (a1*c1+a2*c2+a3*c3)*FC/1000;
%-----Fuel cell depreciation cost
CFR4    = d*((1+d)^Lfc)/((1+d)^Lfc-1);
ADCC4   = InsCost4*CFR4;
Cdp4    = ADCC4*FC/Pi4/8760/cf4+0.02*abs(FC-P4i);
%-----Total cost of Fuel cell
cost_FC = C2 + OM4 + Cem2 + Cdp4; 

