%
% File name:  Gas_dispatch.m
% Contains:   Gas dispatch for micro turbines
	
function [gas_mt_max, gas_required_heat_load] = Gas_dispatch(gas_mt_1,gas_mt_2,gas_mt_3)
heat=[121.0 123.0 124.0 122.0 125.0 117.0 114.0 106.0 97.0 90.0 86.0 ...
       78.0 62.0 57.0 62.0 74.0 98.0 114.0 137.0 154.0 150.0 150.0 ...
      144.0 140.0]; %,MWh
heat=(heat/max(heat))*60;%000; % Household gas load
%plot(heat);

gas_well_1_max =  7.800;%150; % Km^3/h 5300  % kcf/h
%gas_well_1_min =   .400; % Km^3/h
gas_well_2_max =  10.200; % Km^3/h 6000  % kcf/h
%gas_well_2_min =   .600; % Km^3/h

% gas_mt_1      =  65;  %MWh
% gas_mt_2      =  55;  %MWh
% gas_mt_3      =  45;  %MWh
% 1 cubic meter gas can produce 9.6-10.6 kWh. I assume 10.
Gas_efficiency = .1; % Gas_efficiency_factor


gas_required_heat_load = heat*Gas_efficiency;
gas_available_for_mt   = (gas_well_1_max+gas_well_2_max)- gas_required_heat_load;
total_gas_mt_load      = gas_mt_1+gas_mt_2+gas_mt_3;

gas_for_gas_mt_1       = (gas_mt_1/total_gas_mt_load)*gas_available_for_mt;
gas_for_gas_mt_2       = (gas_mt_2/total_gas_mt_load)*gas_available_for_mt;
gas_for_gas_mt_3       = (gas_mt_3/total_gas_mt_load)*gas_available_for_mt;

gas_mt_1_max                       = gas_for_gas_mt_1*6.35; % Gas_efficiency factor 6.35
gas_mt_1_max(gas_mt_1_max>gas_mt_1)= gas_mt_1;

gas_mt_2_max                       = gas_for_gas_mt_2*6.35; % Gas_efficiency factor
gas_mt_2_max(gas_mt_2_max>gas_mt_2)= gas_mt_2;

gas_mt_3_max                       = gas_for_gas_mt_3*6.35; % Gas_efficiency factor
gas_mt_3_max(gas_mt_3_max>gas_mt_3)= gas_mt_3;


gas_mt_max =[gas_mt_1_max; gas_mt_2_max; gas_mt_3_max];
%test = 1;
end