%
% File name:  PandO.m
% Contains:   Solar PV maximum power point tracking
    	
%P&O Tracking algorithm
function [P,V,I]=PandO(sun,v,T)
Vr=zeros(size(sun));
Ir=zeros(size(sun));
for k=1:size(sun)-1
    if size(k)~=0
        Vr0=2.8;
        Vr1=2.8+v;
        Ir0=max60(Vr0,sun(k),T(k));
        Ir1=max60(Vr1,sun(k+1),T(k+1));
        Pr0=Ir0.*Vr0;
        Pr1=Ir1.*Vr1;
        break;
    end
end
for m=k+1:size(sun)-1
    if size(m+1)~=0
        if Pr1>Pr0
            if Vr1>Vr0
                Vr1=Vr1+v;
            else
                Vr1=Vr1-v;
            end
        else
            if Vr1>Vr0
                Vr1=Vr1-v;
            else
                Vr1=Vr1+v;
            end
        end
        Ir0=Ir1;
        Pr0=Pr1;
        Ir1=max60(Vr1,sun(m+1),T(m+1));
        Pr1=Ir1.*Vr1;
        Vr(m+1)=Vr1;
        Ir(m+1)=Ir1;
    end
end
V=Vr;
I=Ir;
P=Vr.*Ir;


