%
% File name:  Pwt.m
% Contains:   Power generation calculation by wind turbine
 	
function P1=Pwt(V)   %Pwt Output power of wind turbine

%Pr_wt = Rated power of wind turbine
%Vci = Cut in wind speed
%Vco = Cut out the wind speed
%Vr = Rated wind speed
%V = Actual wind speed
Vci=2.5;  % Cut in wind speed
Vco=25;   % Cut out the wind speed
Vr=11;    % Rated wind speed
Pr_wt=1; % rated power of wind turbines 3

%  V=[7.2 6.4 6.3 4.7 2.8 3.1 5.3 4.8 4.6 7.6 8.3 8.3 9.7 8.6 10.1 9.2 7.9 8.2 7.6 4.8 5.2 5.5 7.4 5.8]; %Wind speed in summer
%  V=[7.0 6.5 6.4 5.0 3.3 3.6 5.1 5.3 5.3 7.1 6.8 7.7 8.4 6.9 9.1 8.6 7.3 7.5 7.2 4.9 5.5 5.8 7.3 5.8]; %Wind speed in winter
%  V=[6.7 6.3 6.2 4.6 3.4 3.5 4.1 5.2 5.3 6.5 5.0 7.2 6.8 5.1 6.9 7.3 5.3 5.7 5.5 4.7 5.5 5.8 7.1 5.2]; %Wind speed in spring and autumn season

P1=zeros(1,size(V,2));
for i=1:size(V,2)
    if (V(i)<Vci||V(i)>=Vco)
        P1(i)=0;
    else
        if(V(i)<Vr)
            P1(i)=Pr_wt*V(i)*V(i)*V(i)/(Vr*Vr*Vr-Vci*Vci*Vci)-Pr_wt*Vci*Vci*Vci/(Vr*Vr*Vr-Vci*Vci*Vci);
        else
            P1(i)=Pr_wt;
        end
    end
end
